ServerEvents.recipes(event =>{
    event.shapeless(
        Item.of('tconstruct:grout', 8),
        [
            'exdeorum:dust',
            '4x minecraft:gravel',
            '4x minecraft:sand'
        ] 
    )
    event.shapeless(Item.of('kubejs:compressed_grout', 1), [ '9x tconstruct:grout' ])
    event.shapeless(Item.of('minecraft:andesite', 4), [ '2x minecraft:cobblestone', '2x minecraft:gravel' ])
    event.shapeless(Item.of('create:shaft', 8), [ '2x minecraft:andesite' ])
    event.shaped(Item.of('create:andesite_casing', 1), [ 'AAA', 'ALA', 'AAA' ], { A: 'minecraft:andesite', L: '#minecraft:logs' })
    event.shaped(Item.of('create:blaze_burner', 1), [' P ', 'PNP', ' P '], { P: 'create:iron_sheet', N: 'minecraft:netherrack' } )
    event.shaped(Item.of('ars_nouveau:enchanting_apparatus', 1), ['NSN', 'IGI', 'NSN'], {N: 'minecraft:gold_nugget', S: 'ars_nouveau:sourcestone', I: 'minecraft:gold_ingot', G: 'ars_nouveau:source_gem_block'})
    event.shaped(Item.of('create:hand_crank'), ['   ', 'PPP', '  A'], { P: '#minecraft:planks', A: 'minecraft:andesite' })
    event.shaped(Item.of('custommachinery:resource_gen'), ['ICI', 'CAC', 'ICI'], {I: 'minecraft:iron_ingot', C: 'create:iron_sheet', A: 'minecraft:chest'})
    event.shaped(Item.of('custommachinery:natural_gen'), ['LDL','DCD','LDL'], {L: '#minecraft:logs', D: 'minecraft:dirt', C: 'minecraft:chest'})
    event.shaped(Item.of('custommachinery:custom_machine_item', '{machine:"custommachinery:botanical_gen"}'), ['GAG', 'ASA', 'GAG'], { G: 'botania:gaia_ingot', A: 'mythicbotany:alfsteel_ingot', S: 'kubejs:botanical_shard_block' })
    event.shaped(Item.of('custommachinery:custom_machine_item', '{machine:"custommachinery:nether_gen"}'), ['NBN', 'BSB', 'NBN'], {N: 'minecraft:netherrack', B: 'minecraft:blackstone', S: 'kubejs:hardened_shard'})
    			
    //Overworld
    event.shaped('kubejs:overworld_core', ['LDL', 'DBD', 'LDL'], {L: '#minecraft:logs', D: 'minecraft:dirt', B: 'kubejs:basic_resource_shell'})
	event.shapeless('2x minecraft:kelp', 'kubejs:overworld_shard')
	event.shaped('minecraft:prismarine_crystals', ['DDD', 'DDD', 'DDD'], {'D': 'kubejs:overworld_shard'})
	event.shaped('2x minecraft:prismarine_shard', ['DDD', 'D D', 'DDD'], {'D': 'kubejs:overworld_shard'}).noMirror().noShrink()	
	event.shaped('2x minecraft:spider_eye', ['DDD', ' D ', 'DDD'], {'D': 'kubejs:overworld_shard'}).noMirror().noShrink()
	event.shaped('3x minecraft:rotten_flesh', ['D  ', ' D ', '  D'], {'D': 'kubejs:overworld_shard'}).noMirror().noShrink()
	event.shaped('3x minecraft:slime_ball', ['  D', ' D ', 'D  '], {'D': 'kubejs:overworld_shard'}).noMirror().noShrink()
	event.shaped('3x minecraft:sugar_cane', ['DD ', 'DD ', '   '], {'D': 'kubejs:overworld_shard'})
	event.shaped('3x minecraft:wheat_seeds', ['D D', '   ', 'D D'], {'D': 'kubejs:overworld_shard'}).noMirror().noShrink()
	event.shaped('3x minecraft:bone', ['D D', 'D D', '   '], {'D': 'kubejs:overworld_shard'}).noMirror().noShrink()	
    event.shaped('3x minecraft:bamboo', ['D D', '  ', 'D D'], {'D': 'kubejs:overworld_shard'}).noMirror().noShrink()	
    
    // Nether
    event.shaped('minecraft:quartz', ['D D',' D ','D D'], {'D': 'kubejs:nether_shard'}).noMirror().noShrink()
	event.shaped('2x minecraft:glowstone_dust', ['DDD'], {'D': 'kubejs:nether_shard'}).noMirror().noShrink()
	event.shaped('minecraft:soul_sand', ['D  ', ' D ', '  D'], {'D': 'kubejs:nether_shard'}).noMirror().noShrink()
	event.shaped('minecraft:magma_cream', ['  D', ' D ', 'D  '], {'D': 'kubejs:nether_shard'}).noMirror().noShrink()
	event.shapeless('minecraft:nether_wart', 'kubejs:nether_shard')
	event.shaped('minecraft:ghast_tear', ['DDD','   ','DDD'], {'D': 'kubejs:nether_shard'}).noMirror().noShrink()
    event.shaped('minecraft:netherite_scrap', ['DDD','DDD','DDD'], {D: 'kubejs:nether_shard'})
    event.shaped('tconstruct:raw_cobalt', ['D D', 'D D','D D'], {D: 'kubejs:nether_shard'})
    event.shaped('immersiveengineering:raw_uranium', ['DDD','D D','DDD'], {D: 'kubejs:nether_shard'})
    event.shaped('kubejs:nether_core', ['NSN','SGS','NSN'], { N:'minecraft:netherrack', S:'minecraft:soul_sand', G:'minecraft:gold_block' })

    //misc
    event.shaped('kubejs:certus_resource_core', ['CCC','CSC','CCC'], {C:'ae2:quartz_block', S: 'kubejs:hardened_shard'})
    event.shaped('kubejs:fluix_resource_core', ['CCC','CSC','CCC'], {C:'ae2:fluix_block', S: 'kubejs:hardened_shard'})
    event.shapeless('occultism:iesnium_ingot', ['kubejs:diamond_resource_core', 'kubejs:netherite_resource_core'])
    event.shaped('kubejs:plutonium_resource_core', ['CCC', 'CSC', 'CCC'], {C: 'mekanism:pellet_plutonium', S: 'kubejs:antimatter_resource_core'})
    event.shaped('kubejs:polonium_resource_core', ['CCC', 'CSC', 'CCC'], {C: 'mekanism:pellet_polonium', S: 'kubejs:antimatter_resource_core'})

    // Shard Blocks
    event.shapeless('9x kubejs:energized_shard', 'kubejs:energized_shard_block')
    event.shapeless('9x kubejs:botanical_shard', 'kubejs:botanical_shard_block')
    event.shapeless('kubejs:energized_shard_block', '9x kubejs:energized_shard')
    event.shapeless('kubejs:botanical_shard_block', '9x kubejs:botanical_shard')

    event.shaped(Item.of('kubejs:gen_speed_upgrade'), ['RGR', 'GSG', 'RGR'], { R: 'minecraft:redstone', G: 'minecraft:gold_ingot', S: 'kubejs:magic_shard' })
})